<template>
  <div class='btn-group'>
    <button class='btn' 
            v-bind:class="{ 'btn-success': !runningTask, 'btn-warning': runningTask }"
            @click="taskAction()"> 
            <div v-if='runningTask'> Stop </div> 
            <div v-else> Start </div>
    </button>

    <button class='btn' style='width:120px;'>
      <timer :init-time='Math.round(task.duration)' :timer-id='task.id'></timer>
    </button>
    <button class='btn' style='width:200px;'>
      <div v-if='runningTask'> Running</div>
      <div v-else> Not Running</div>
    </button>
    <button class='btn btn-danger' @click="deleteTask(task)">
      Delete
    </button>

  </div>
</template>

<script>
  export default {
    data () {
      return {
        runningTask: this.task.running
      }
    },
    props: ['task'],
    methods: {
      taskAction() {
        if(this.runningTask) {
          this.stopTask()
        } else {
          this.startTask()
        }
        this.runningTask = !this.runningTask
      },
      startTask() {
        const url = '/api/v1/time_points/start'
        this.$http.post(url, {time_point: { task_id: this.task.id }}, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'normal' })
          this.$root.$emit('startTimer-' + this.task.id)
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
        })
      },
      stopTask() {
        const url = '/api/v1/time_points/finish'
        this.$http.patch(url, {time_point: { task_id: this.task.id }}, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'normal' })
          this.$root.$emit('stopTimer-' + this.task.id )
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
        })
      },
      deleteTask(task) {
        const url = `/api/v1/tasks/${task.id}`
        this.$http.delete(url, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'normal' })
          this.$parent.deleteTask(task)
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
        })
      }
    }
  }
</script>
